/**************************************************************************************
* This file is part of the GameFramework project released by Wazoo Enterprises Inc.
* under the GNU Public License. 
*
* Any projects using this code must attach these copyright notices along with their
* own as outlined at http://www.gnu.org
*
* Copyright 2003 by Wazoo Enterprises Inc.
* To contact the auther, send a message to wazoo@wazooenterprises.com
*
****************************************************************************************/

#include "GameOGLRenderer.h"
#include "OGLRenderer.h"

///////////////////////////////////////
// DLL Entry Point
///////////////////////////////////////
BOOL WINAPI DllEntryPoint( HINSTANCE hDll,
                           DWORD     fdwReason,
                           LPVOID    lpvReserved )
{
  ////////////////////////////
  //  Let's find out exactly why Windows called us...
  ///////////////////////////////////////////////////
  switch( fdwReason )
  {
	// called when we attach to the DLL
    case DLL_PROCESS_ATTACH:
      //////////////////////////////
      //  Here we would normally do some startup stuff, like saving the
      //  hDll parameter to a global variable, allocating memory for
      //  local structures and stuff, etc...
    
      break;
	// called when we free or detach from the DLL
    case DLL_PROCESS_DETACH:
      //////////////////////////////
      //  Here we would free the memory and stuff we allocated in
      //  response to DLL_PROCESS_ATTACH.
     
      break;

    default:
      //////////////////////////////
      //  If fdwReason isn't the above two cases, we'll just ignore it
      
      break;
  };

  /////////////////////////////////
  //  If we had run into an error (like not being able to allocate memory
  //  or something else) we would return FALSE.  This would tell Windows
  //  that we were unnable to succesfully initialize.  If this DLL was
  //  being loaded by a program as it started, the program would fail to
  //  load.  If this DLL was being loaded by a running program via a call
  //  to LoadLibrary(), LoadLibrary would return NULL to the calling program.
  
  return TRUE;
}

HRESULT createRendererInterface(rendererInterface **pInterface)
{
	if(!*pInterface)
	{
		//convert our interface pointer to a OGLRenderer object
		*pInterface = new OGLRenderer;
		return S_OK;
	}

	return E_FAIL;

}

// Release our Handle to the class
HRESULT destroyRendererInterface(rendererInterface **pInterface)
{
	if(!*pInterface)
	{
		return E_FAIL;
	}
	delete *pInterface;
	*pInterface = 0;
	return S_OK;
}
