
#ifndef __RENDERERFACTORY_H_
#define __RENDERERFACTORY_H_
/**************************************************************************************
* This file is part of the GameFramework project released by Wazoo Enterprises Inc.
* under the GNU Public License. 
*
* Any projects using this code must attach these copyright notices along with their
* own as outlined at http://www.gnu.org
*
* Copyright 2003 by Wazoo Enterprises Inc.
* To contact the auther, send a message to wazoo@wazooenterprises.com
*
****************************************************************************************/

/////////////////////////////
// Class: rendererFactory
// Description: This Factory object is solely responsible for the
//              proper creation of our rendererInterface object.
//              Rather than clutter up our main game code with
//              run-time DLL linking code, we can encapsulate all
//              of that into this object. 
//
/////////////////////////////
#include "rendererInterface.h"

class rendererFactory
{
private:
	rendererInterface	*m_pRenderer;

	HINSTANCE           m_hInst;
   	HMODULE             m_hDLL;

   public:
   	  rendererFactory(HINSTANCE hInst);
   	  ~rendererFactory();

	  //Version1.1
	  //Modified the method to accept a HWND that we can modify the text to
   	  HRESULT initInterface(TCHAR *szType, HWND);


   	  rendererInterface* getInterface(){ return m_pRenderer; };
   	  void destroyInterface();
};

#endif